<?php
/**
 * @ H2N Link Directory 1.0.0 linkdirectory.links.php
 * @ Copyright (C) 2008 Harry Klein - joomla.neschke.eu
 * @
 * @ Link Directory 1.1 linkdirectory.links.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

function DetailLink($id, $option, $Itemid, $limitstart) {
	global $database, $mainframe, $my, $ld, $temp;

	$row = new snrLinks( $database );
	// load the row from the db table
	$row->load( $id );

	if (empty($row) || $row->published != 1) {
		mosNotAuth();
		return;
	} else {
		# increase hits
		$cookiename = "ldhit$row->id";
		$visited = mosGetParam( $_COOKIE, $cookiename, '0' );

		if (!$visited) {
			$database->setQuery( "UPDATE #__ldlinks SET hits=hits+1 WHERE id=$id");
			$database->query();
			setcookie( $cookiename, '1', time()+86400 );
		}

		$database->setQuery("SELECT title FROM #__ldcats WHERE id = $row->catid");
		$cattitle = $database->loadResult();

		//Get total comments
		$query = "SELECT COUNT( rev_id )"
		. "\n FROM #__ldcomment"
		. "\n WHERE link_id = ". $row->id
		. "\n AND rev_approved = 1"
		;

		$database->setQuery( $query );
		$comment = $database->loadResult();
		$row->comment = $comment;
		$row->description = nl2br($row->description);

		if ($ld->dpage) {
			$mainframe->SetPageTitle( _LD_HOME .' - '. $cattitle . ' - '. $row->title );
		} else {
			$mainframe->SetPageTitle( _LD_HOME );
		}

		$detailurl = getItemUrl('detail',$row->id,$Itemid);
		$rateurl = getItemUrl('rate',$row->id,$Itemid);
		$commenturl = getItemUrl('comment',$row->id,$Itemid);
		$reporturl = getItemUrl('report',$row->id,$Itemid);
		$row->url = getUrlToLink($row->url,$row->id,$Itemid);
		
		$temp->id = $id;
		$temp->row = $row;
		$temp->catid = $row->catid;
		$temp->option = $option;
		$temp->Itemid = $Itemid;
		$temp->limitstart = $limitstart;
		$temp->ratelink = $ld->ratelink;
		$temp->commentlink = $ld->commentlink;
		$temp->badlink = $ld->badlink;
		$temp->showfastlink = $ld->showfastlink;
		$temp->copyrigthinfo = $ld->copyrigthinfo;
		$temp->version = $ld->version;
		$temp->showlongdescription  = $ld->ldlongdetail;

		$temp->detailurl = $detailurl;
		$temp->rateurl = $rateurl;
		$temp->commenturl = $commenturl;
		$temp->reporturl = $reporturl;

		$temp->display('header.tpl.php');
		$temp->display('linkdetail.tpl.php');
		$temp->display('showcomments.tpl.php');
		$temp->display('footer.tpl.php');

		//Weblinks_HTML::ViewLinks($row, $option, $Itemid, $limitstart);
	}
}

function editLink( $id, $option, $catid, $Itemid ) {
	global $database, $Itemid,$ld, $temp;
	
	$row = new snrLinks( $database );
	$row->load( $id );
	if (!$row->bind( $_POST, 'published' )) {
  		mosErrorAlert( $row->getError() );
	}
	viewLinkForm ($row, $option, $catid, $Itemid);
}	
	
	
function viewLinkForm ($row, $option, $catid, $Itemid){	
	global $database, $Itemid,$ld, $temp;
	$options = array();
	$options[] = mosHTML::makeOption('', _SEL_CATEGORY );
	$lists['parent'] = ComponentCategory('catid', $catid);

	$sugcategory = sefReltoAbs('index.php?option=com_linkdirectory&amp;task=suggestcat&amp;catid='.$catid.'&amp;Itemid='.$Itemid);

	$temp->row = $row;
	$temp->option = $option;
	$temp->scat = $ld->scat;
	$temp->parent = $lists['parent'];
	$temp->catid = $catid;
	$temp->suglink = $sugcategory;
	$temp->securityimage = $ld->securityimage;
	$temp->ldeditor = $ld->ldeditor;
	$temp->Itemid = $Itemid;

	$temp->display('header.tpl.php');
	$temp->display('editlink.tpl.php');
}

/**
 * Saves the record on an edit form submit
 * @param database A database connector object
 */
function saveLink($id, $option, $catid, $Itemid) {
	$msg='';
	global $mosConfig_mailfrom, $mosConfig_fromname;
	global $database, $my, $mosConfig_absolute_path, $ld;

	$checkSecurity = validateCaptcha();

	if (!$checkSecurity) {
		displayError(_LD_LINK_REFUSED);
		editLink( $id, $option, $catid, $Itemid );
	} else {
		$row = new snrLinks( $database );
		$row->load( $id );
		if (!$row->bind( $_POST, 'published' )) {
			displayError($row->getError());
			return;
		}
		$isNew = $row->id < 1;

		if ($row->id) {
			$row->modified = date( 'Y-m-d H:i:s' );
		}else {
			$row->created = date( 'Y-m-d H:i:s' );
		}

		if (!$row->check()) {
			displayError($row->getError());
			editLink( $id, $option, $catid, $Itemid);
			return;
		}
		
		if (!$row->store()) {
			displayError($row->getError());
			editLink( $id, $option, $catid, $Itemid);
			return;
		}

		$row->checkin();

		// admin users gid
		$gid = 25;
		$gid2 = 24;

		// list of admins	
		$query = "SELECT email, name"
		. "\n FROM #__users"
		. "\n WHERE ( gid = $gid"
		. "\n or gid = $gid2) "
		. "\n AND sendEmail = 1"
		;
		$database->setQuery( $query );
		if(!$database->query()) {
			displayError($database->stderr( true ));
			return;
		}
		$adminRows = $database->loadObjectList();

		// send email notification to admins
		foreach($adminRows as $adminRow) {
			mosSendAdminMail($adminRow->name, $adminRow->email, '', _LD_LINKADDMSG, $row->title, $my->username );
		}

		$msg 	= $isNew ? _LD_THANK_SUB : '';
		mosRedirect( 'index.php?option=com_linkdirectory&Itemid='. $Itemid , $msg );
	}
}

function ViewLink($id) {
	global $database, $my, $mainframe;

	$link = new snrLinks($database);
	$link->load($id);

	if (!$link->published) {
		mosNotAuth();
		return;
	}

	$cat = new snrCats($database);
	$cat->load($link->catid);

	if (!$cat->published) {
		mosNotAuth();
		return;
	}

	if ( $cat->access > $my->gid ) {
		mosNotAuth();
		return;
	}

	if ( $link->url ) {
		mosRedirect ( $link->url );
	} else {
		ViewCategory( $catid, $option, $Itemid );
	}
}


?>