<?php
/**
 * @ H2N Link Directory 1.0.0 linkdirectory.search.php
 * @ Copyright (C) 2008 Harry Klein - joomla.neschke.eu
 * @
 * @ Link Directory 1.1 linkdirectory.search.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
/**
 * Suche nach Links. Es wird nach dem Titel der Links gesucht.
 *
 * @param string $searchtext Text, nach dem gesucht werden soll
 * @param int $catid Kategorieid, unterhalb der die Suche erfolgen soll
 * @param string $option
 * @return void
 */
function SearchLinks($searchtext, $catid, $option) {
	global $database, $mainframe, $mosConfig_absolute_path, $ld, $my, $temp, $Itemid;
	$searchtext = $database->getEscaped( trim( strtolower( $searchtext ) ) );
	//$catid		= intval( $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 ) );
	$limitstart = intval(mosGetParam($_GET, 'limitstart', 0));

	if ($searchtext) {
		$where = array();
		$where[] = '#__ldlinks.published = 1';

		getWhereAllSubCategoriesForLinks($catid,$where);
		getWhereSearchtextForLink($searchtext,$where);
		getWhereForLinksAndPublishCat($where);

		$whereAsString = count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "" ;
		$total = getTotalCountOfLinkMatches($whereAsString);

		//get results from db
		$query = "SELECT #__ldlinks.* FROM #__ldlinks, #__ldcats " . $whereAsString
		. "\n ORDER BY $ld->linkorder"
		. "\n LIMIT $limitstart, $ld->limitlink" ;
		$database->setQuery($query);
		$rows_of_links = $database->loadObjectList();
	} else {
		$rows_of_links=NULL;
		$total = 0;
	}

	$tabclass = array( 'link1', 'link2' );
	$mainframe->setPageTitle( _LD_HOME.'- '.html_entity_decode(str_replace('$msg',$searchtext,_LD_SEARCH_RESULT)));
	$temp->id = NULL;
	$temp->catid = $catid;
	$temp->rows_of_links = $rows_of_links;
	$temp->found=(bool)$rows_of_links;
	$temp->option = $option;
	$temp->pageNav = getPageNavigation($total,$limitstart);
	$temp->ratelink = $ld->ratelink;
	$temp->commentlink = $ld->commentlink;
	$temp->showfastlink = $ld->showfastlink;
	$temp->showhits = $ld->showhits;
	$temp->Itemid = $Itemid;
	$temp->tabclass = $tabclass;
	$temp->copyrigthinfo = $ld->copyrigthinfo;
	$temp->version = $ld->version;
	$temp->showlongdescription  = $ld->ldlonglist;
	
	$temp->pageNavUrl=getSearchURL('search',$searchtext,'links',$catid,$Itemid);
	$temp->searchtext=$searchtext;
	$temp->display('header.tpl.php');
	$temp->display('userpanel.tpl.php');
	$temp->display('searchresult.tpl.php');
	$temp->display('linklists.tpl.php');
	$temp->display('footer.tpl.php');
}


function SearchCategories($searchtext, $catid, $option) {
	global $database, $mainframe, $mosConfig_absolute_path, $ld, $my, $temp, $Itemid;
	$searchtext = $database->getEscaped( trim( strtolower( $searchtext ) ) );
	//$catid		= intval( $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 ) );
	$limitstart = intval(mosGetParam($_GET, 'limitstart', 0));

	if ($searchtext) {
		$where = array();
		$where[] = "published = 1";
		getWhereAllSubCategoriesForCats($catid,$where);
		getWhereSearchtextForCat($searchtext,$where);

		$whereAsString = count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "" ;
		$total = getTotalCountOfCatMatches($whereAsString);

		//get results from db
		$query = "SELECT * FROM #__ldcats " . $whereAsString . " LIMIT $limitstart, $ld->limitlink"	;
		$database->setQuery($query);
		$rows_of_categories = $database->loadObjectList();

	} else {
		$rows_of_links=NULL;
		$total = 0;
	}

	$tabclass = array( 'link1', 'link2' );
	$mainframe->setPageTitle( _LD_HOME.'- '.html_entity_decode(_LD_SEARCH_RESULT).' ['. $searchtext .']');
	$temp->id = NULL;
	$temp->catid = $catid;
	$temp->rows_of_categories = $rows_of_categories;
	$temp->found=(bool)$rows_of_categories;
	$temp->option = $option;
	$temp->pageNav = getPageNavigation($total,$limitstart);
	$temp->Itemid = $Itemid;
	$temp->tabclass = $tabclass;

	$temp->pageNavUrl=getSearchURL('search',$searchtext,'categories',$catid,$Itemid);
	$temp->searchtext=$searchtext;

	$temp->column = $ld->column;
	$temp->catimage = $ld->catimage;
	$temp->tlink = $ld->tlink;
	$temp->tslink = $ld->tslink;
	$temp->catdesc = $ld->catdesc;
	$temp->copyrigthinfo = $ld->copyrigthinfo;
	$temp->version = $ld->version;

	$temp->display('header.tpl.php');
	$temp->display('userpanel.tpl.php');
	$temp->display('searchresult.tpl.php');
	$temp->display('categorysearchlist.tpl.php');
	$temp->display('footer.tpl.php');
}

// ===========================================================================
// = Helper für die Ermittlung aller SubCategorien 
// ===========================================================================

/**
 * Liefert where-Klausel, um Links in der aktuellen und deren Unterkategorien suchen zu können.
 *
 * @param int $catid Katehorie-Id
 * @param Array mit $where-Klausel, deren Elemente später mit AND verknüpft werden
 * @global ld->searchonlyinsubcats
 * @see #getWhereAllSubCategoriesFor
 *
 */
function getWhereAllSubCategoriesForLinks($catid,&$where){
	getWhereAllSubCategoriesFor($catid,'catid',$where);
}

/**
 * Liefert where-Klausel, um Kategorien in der aktuellen und deren Unterkategorien suchen zu können.
 *
 * @param int $catid Katehorie-Id
 * @param Array mit $where-Klausel, deren Elemente später mit AND verknüpft werden
 * @global ld->searchonlyinsubcats
 * @see #getWhereAllSubCategoriesFor
 *
 */
function getWhereAllSubCategoriesForCats($catid,&$where){
	getWhereAllSubCategoriesFor($catid,'id',$where);
}

/**
 * Where-Klausel, um aktuelle und alle deren Unterkategorien zu ermitteln.
 *
 * @param int $catid Katehorie-Id
 * @param $columnName Spaltenname der KategoieId in der Tabelle #__ldlinks bzw. #__ldcats
 * @param Array mit $where-Klausel, deren Elemente später mit AND verknüpft werden
 * @global ld->searchonlyinsubcats
 */
function getWhereAllSubCategoriesFor($catid,$columnName,&$where){
	global $database,$my,$ld;
	if ( ( $catid > 0 ) && $ld->searchonlyinsubcats) {
		$whereSubCat[] = "$columnName = $catid";
		getAllSubCategoriesFromCategorie($catid,$columnName,$whereSubCat);

		if (count ($whereSubCat) == 1){
			$where[] = $whereSubCat[0];
		}elseif (count ($whereSubCat) > 1){
			$where[] = '(' . implode( ' OR ', $whereSubCat ) .')';
		}
	}
}

function getAllSubCategoriesFromCategorie($catid,$columnName,&$whereSubCat) {
	global $database,$my,$ld;
	$database->setQuery("SELECT id FROM #__ldcats WHERE parent_id = $catid AND published = 1 AND access <= $my->gid");
	$subcats = $database->loadObjectList();
	if (count($subcats)) {
		foreach ($subcats as $subcat) {
			$whereSubCat[] = "$columnName = $subcat->id";
			getAllSubCategoriesFromCategorie($subcat->id,$columnName,$whereSubCat);
		}
	}
}

// ===========================================================================
// = Helper für die Seiten-Navigation                                        = 
// ===========================================================================

/**
 * Liefert die Seiten-Navigation.
 *
 * @param int $total Gesamtanzahl der Treffer
 * @param int $limitstart
 * @return Seitennavigation mosPageNav, wenn $total > 0, sonst NULL
 */
function getPageNavigation(&$total,&$limitstart){
	global $ld;
	$pageNav = NULL;
	if ($total > 0 ){
		require_once(  _LD_ABSOLUTE_PATH . '/includes/pageNavigation.php' );
		if (($total > $ld->limitlink) && ($ld->limitlink > 0)) {
			$pageNav = new mosPageNav( $total, $limitstart, $ld->limitlink );
		}
	}
	return $pageNav;
}

/**
 * Liefert die Anzahl der Treffer bei der Suche nach Links
 *
 * @param string $whereAsString Where-Klausel zum Suchen
 * @return int Anzahl der Treffer
 * @global $database
 */
function getTotalCountOfLinkMatches($whereAsString ){
	global $database;
	$query = "SELECT COUNT(*) FROM #__ldlinks, #__ldcats " . $whereAsString ;
	$database->setQuery($query);
	$total = $database->loadResult();
	return $total;
}

/**
 * Liefert die Anzahl der Treffer bei der Suche nach Kategorien
 *
 * @param string $whereAsString Where-Klausel zum Suchen
 * @return int Anzahl der Treffer
 * @global $database
 */
function getTotalCountOfCatMatches($whereAsString ){
	global $database;
	$query = "SELECT COUNT(*) FROM #__ldcats " . $whereAsString ;
	$database->setQuery($query);
	$total = $database->loadResult();
	return $total;
}

// ===========================================================================
// = Helper für den Zusammenbau von where-Klauseln                           = 
// ===========================================================================

/**
 * Konvertiert das Array $whereSearch in ein String, indem es die einzelnen Elemente mit $op verknüft.
 * Das Ergebnis wird dem Array $where hinzugefügt. 
 *
 * @param array  $whereSearch
 * @param String $op AND oder OR
 * @param array $where (wird verändert)
 */
function convertWhereArrayToString(&$whereSearch,$op,&$where){
	$count=count($whereSearch);
	if ($count > 1) {
		$where[] = '(' . implode( ' '.$op.' ', $whereSearch ) .')';
	}
	elseif ($count == 1) {
		$where[] = $whereSearch[0];
	}
	elseif ($count == 0) {
		$where[] = '1=0';
	}
}

function getWhereForLinksAndPublishCat(&$where){
	$where[] = '#__ldlinks.catid = #__ldcats.id';
	$where[] = '#__ldcats.published = 1';
}

/**
 * Baut den where-Klause bzgl. des Suchtextes für die Suche nach Links zusammen.
 *
 * @param String $searchtext Suchtext
 * @param array $where where-Klausel
 * @global $ld->searchtitle
 * @global $ld->searchurl
 * @global $ld->searchdesc
 * @global $ld->searchlongdesc
 */
function getWhereSearchtextForLink($searchtext,&$where){
	global $ld;
	if ( $searchtext ) {
		$whereSearch = array();
		if ($ld->searchtitle){
			$whereSearch[] = "LOWER(#__ldlinks.title) LIKE '%$searchtext%'";
		}
		if ($ld->searchurl){
			$whereSearch[] = "LOWER(#__ldlinks.url) LIKE '%$searchtext%'";
		}
		if ($ld->searchdesc){
			$whereSearch[] = "LOWER(#__ldlinks.description) LIKE '%$searchtext%'";
		}
		if ($ld->searchlongdesc){
			$whereSearch[] = "LOWER(#__ldlinks.description_long) LIKE '%$searchtext%'";
		}
		convertWhereArrayToString($whereSearch,'OR',$where);
	}
}

/**
 * Baut den where-Klause bzgl. des Suchtextes für die Suche nach Kategorien zusammen.
 *
 * @param String $searchtext Suchtext
 * @param array $where where-Klausel
 * @global $ld->searchcattitel
 * @global $ld->searchcatdesc
 */
function getWhereSearchtextForCat($searchtext,&$where){
	global $ld;
	if ( $searchtext ) {
		$whereSearch = array();
		if ($ld->searchcattitle){
			$whereSearch[] = "LOWER(title) LIKE '%$searchtext%'";
		}
		if ($ld->searchcatdesc){
			$whereSearch[] = "LOWER(description) LIKE '%$searchtext%'";
		}
		convertWhereArrayToString($whereSearch,'OR',$where);
	}
}

// ===========================================================================
// = Helper                                                                  =
// ===========================================================================

function isLinkSearchEnable(){
	global $ld;
	return (bool)(($ld->searchtitle || $ld->searchurl || $ld->searchdesc ||$ld->searchlongdesc) && 	($ld->sengine));
}

function isCategorySearchEnable(){
	global $ld;
	return (bool)(($ld->searchcattitle || ($ld->searchcatdesc)) && $ld->sengine);
}

function isSearchEnable(){
	return (bool)(isLinkSearchEnable()|| isCategorySearchEnable());
}


?>